//+------------------------------------------------------------------+
//|                                                Grassroot 104.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 MediumPurple
//--- buffers
double ExtMapBuffer1[];
extern int short_period = 30;
extern int long_period = 204;   

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,ExtMapBuffer1);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars = IndicatorCounted();
   if (counted_bars < 0) return(-1);
    
   double dir0;
   int i;
        
   for(i = Bars-counted_bars-1; i>=0; i--)
   {
      dir0 = iMA(NULL, 0, short_period, 0, MODE_EMA, PRICE_CLOSE, i) - iMA(NULL, 0 , long_period, 0, MODE_EMA, PRICE_CLOSE, i);
      ExtMapBuffer1[i] = dir0;
   }
   
   return(0);
  }
//+------------------------------------------------------------------+