//+------------------------------------------------------------------+
//|                                                Grassroot 104.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Tomato
#property indicator_color2 Tomato
#property indicator_color3 MediumPurple
#property indicator_color4 MediumPurple
#property indicator_style1 STYLE_DOT
#property indicator_style2 STYLE_DOT
#property indicator_style3 STYLE_DOT
#property indicator_style4 STYLE_DOT

//--- buffers
double ExtMapBuffer1[], ExtMapBuffer2[], ExtMapBuffer3[], ExtMapBuffer4[];
extern int prd = 55;
extern double sftr = 0.04;   
extern bool show_originalband = false;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,ExtMapBuffer4);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars = IndicatorCounted();
   if (counted_bars < 0) return(-1);
    
   double hhv0, llv0; 
   int i;
        
   for(i = Bars-counted_bars-1; i>=0; i--)
   {
      hhv0 = High[iHighest(NULL, 0, MODE_HIGH, prd, i+1)];
      llv0 = Low[iLowest(NULL, 0, MODE_LOW, prd, i+1)];
   
      if(show_originalband)
      {
         ExtMapBuffer1[i] = hhv0;
         ExtMapBuffer2[i] = llv0;
      }
      ExtMapBuffer3[i] = hhv0 * (1+sftr/100);
      ExtMapBuffer4[i] = llv0 * (1-sftr/100);
   }
   
   return(0);
  }
//+------------------------------------------------------------------+